---
title: "Schedule a saved report for delivery"
description: "\n\n### Quire permissions\n\nRequired capability: `report/schedule`.\n\nCredential scopes: `reports:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › reports

`POST /report_schedules`

\### Quire permissions

Required capability: `report/schedule`.

Credential scopes: `reports:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `reports:write`
- `oauth2`, oauth2, scopes: `reports:write`

## Header parameters

- `createReportSchedule.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `createReportSchedule.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `createReportSchedule.report_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `createReportSchedule.frequency` (string, required)
  - one of `"daily"`, `"weekly"`, `"monthly"`
- `createReportSchedule.hour_local` (integer, required)
  - min 0; max 23
- `createReportSchedule.timezone` (string, required)
  - minLength 1; maxLength 64
- `createReportSchedule.format` (string, required)
  - one of `"csv"`, `"xlsx"`, `"ods"`, `"json"`, `"ndjson"`, `"pdf"`
- `createReportSchedule.recipient_ids` (array<string>, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `createReportSchedule.day_of_week` (any of, optional)
  - any of: `integer`, `null`
- `createReportSchedule.day_of_month` (any of, optional)
  - any of: `integer`, `null`
- `createReportSchedule.enabled` (boolean, optional)
- `createReportSchedule.external_id` (string, optional)
  - minLength 1; maxLength 255

## Example request

```json
{
  "report_id": "5ed7905a-4735-4cf7-b1ab-521e066fb971",
  "frequency": "daily",
  "day_of_week": 1,
  "day_of_month": 1,
  "hour_local": 23,
  "timezone": "string",
  "format": "csv",
  "recipient_ids": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ],
  "enabled": true,
  "external_id": "string"
}
```

## Code samples

### cURL

```curl
curl --request POST \
  --url https://your-organisation.quirelms.com/api/v1/report_schedules \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "report_id": "5ed7905a-4735-4cf7-b1ab-521e066fb971",
  "frequency": "daily",
  "day_of_week": 1,
  "day_of_month": 1,
  "hour_local": 23,
  "timezone": "string",
  "format": "csv",
  "recipient_ids": [
    "497f6eca-6276-4993-bfeb-53cbbbba6f08"
  ],
  "enabled": true,
  "external_id": "string"
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/report_schedules';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    report_id: '5ed7905a-4735-4cf7-b1ab-521e066fb971',
    frequency: 'daily',
    day_of_week: 1,
    day_of_month: 1,
    hour_local: 23,
    timezone: 'string',
    format: 'csv',
    recipient_ids: ['497f6eca-6276-4993-bfeb-53cbbbba6f08'],
    enabled: true,
    external_id: 'string'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/report_schedules"

payload = {
    "report_id": "5ed7905a-4735-4cf7-b1ab-521e066fb971",
    "frequency": "daily",
    "day_of_week": 1,
    "day_of_month": 1,
    "hour_local": 23,
    "timezone": "string",
    "format": "csv",
    "recipient_ids": ["497f6eca-6276-4993-bfeb-53cbbbba6f08"],
    "enabled": True,
    "external_id": "string"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 201

Success.

#### Example

```json
{
  "id": "string",
  "external_id": "string",
  "report_id": "string",
  "frequency": "daily",
  "day_of_week": -9007199254740991,
  "day_of_month": -9007199254740991,
  "hour_local": -9007199254740991,
  "timezone": "string",
  "format": "csv",
  "delivery": "attach",
  "recipient_ids": [
    "string"
  ],
  "enabled": true,
  "rrule": "string",
  "next_run_at": "string",
  "last_run_at": "string",
  "last_error": "string",
  "created_by": "string",
  "created_at": "string",
  "updated_at": "string",
  "deleted_at": "string"
}
```

- `createReportSchedule.response.201.id` (string, required)
- `createReportSchedule.response.201.external_id` (string | null, required)
- `createReportSchedule.response.201.report_id` (string, required)
- `createReportSchedule.response.201.frequency` (string, required)
  - one of `"daily"`, `"weekly"`, `"monthly"`
- `createReportSchedule.response.201.day_of_week` (any of, required)
  - any of: `integer`, `null`
- `createReportSchedule.response.201.day_of_month` (any of, required)
  - any of: `integer`, `null`
- `createReportSchedule.response.201.hour_local` (integer, required)
  - min -9007199254740991; max 9007199254740991
- `createReportSchedule.response.201.timezone` (string, required)
- `createReportSchedule.response.201.format` (string, required)
  - one of `"csv"`, `"xlsx"`, `"ods"`, `"json"`, `"ndjson"`, `"pdf"`
- `createReportSchedule.response.201.delivery` (string, required)
  - one of `"attach"`, `"link"`
- `createReportSchedule.response.201.recipient_ids` (array<string>, required)
- `createReportSchedule.response.201.enabled` (boolean, required)
- `createReportSchedule.response.201.rrule` (string | null, required)
- `createReportSchedule.response.201.next_run_at` (string, required) — RFC 3339 timestamp in UTC.
- `createReportSchedule.response.201.last_run_at` (any of, required)
  - any of: `string`, `null`
- `createReportSchedule.response.201.last_error` (string | null, required)
- `createReportSchedule.response.201.created_by` (string | null, required)
- `createReportSchedule.response.201.created_at` (string, required) — RFC 3339 timestamp in UTC.
- `createReportSchedule.response.201.updated_at` (string, required) — RFC 3339 timestamp in UTC.
- `createReportSchedule.response.201.deleted_at` (any of, required)
  - any of: `string`, `null`

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.401.type` (string, required)
  - format `uri`
- `createReportSchedule.response.401.title` (string, required)
- `createReportSchedule.response.401.status` (integer, required)
- `createReportSchedule.response.401.code` (string, required)
- `createReportSchedule.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.401.detail` (string, required)
- `createReportSchedule.response.401.request_id` (string, required)
- `createReportSchedule.response.401.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.401.errors` (array<object>, optional)
  - `createReportSchedule.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.401.errors.code` (string, required)
  - `createReportSchedule.response.401.errors.detail` (string, required)
- `createReportSchedule.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.403.type` (string, required)
  - format `uri`
- `createReportSchedule.response.403.title` (string, required)
- `createReportSchedule.response.403.status` (integer, required)
- `createReportSchedule.response.403.code` (string, required)
- `createReportSchedule.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.403.detail` (string, required)
- `createReportSchedule.response.403.request_id` (string, required)
- `createReportSchedule.response.403.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.403.errors` (array<object>, optional)
  - `createReportSchedule.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.403.errors.code` (string, required)
  - `createReportSchedule.response.403.errors.detail` (string, required)
- `createReportSchedule.response.403.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.409.type` (string, required)
  - format `uri`
- `createReportSchedule.response.409.title` (string, required)
- `createReportSchedule.response.409.status` (integer, required)
- `createReportSchedule.response.409.code` (string, required)
- `createReportSchedule.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.409.detail` (string, required)
- `createReportSchedule.response.409.request_id` (string, required)
- `createReportSchedule.response.409.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.409.errors` (array<object>, optional)
  - `createReportSchedule.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.409.errors.code` (string, required)
  - `createReportSchedule.response.409.errors.detail` (string, required)
- `createReportSchedule.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.422.type` (string, required)
  - format `uri`
- `createReportSchedule.response.422.title` (string, required)
- `createReportSchedule.response.422.status` (integer, required)
- `createReportSchedule.response.422.code` (string, required)
- `createReportSchedule.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.422.detail` (string, required)
- `createReportSchedule.response.422.request_id` (string, required)
- `createReportSchedule.response.422.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.422.errors` (array<object>, optional)
  - `createReportSchedule.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.422.errors.code` (string, required)
  - `createReportSchedule.response.422.errors.detail` (string, required)
- `createReportSchedule.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.429.type` (string, required)
  - format `uri`
- `createReportSchedule.response.429.title` (string, required)
- `createReportSchedule.response.429.status` (integer, required)
- `createReportSchedule.response.429.code` (string, required)
- `createReportSchedule.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.429.detail` (string, required)
- `createReportSchedule.response.429.request_id` (string, required)
- `createReportSchedule.response.429.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.429.errors` (array<object>, optional)
  - `createReportSchedule.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.429.errors.code` (string, required)
  - `createReportSchedule.response.429.errors.detail` (string, required)
- `createReportSchedule.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `createReportSchedule.response.500.type` (string, required)
  - format `uri`
- `createReportSchedule.response.500.title` (string, required)
- `createReportSchedule.response.500.status` (integer, required)
- `createReportSchedule.response.500.code` (string, required)
- `createReportSchedule.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `createReportSchedule.response.500.detail` (string, required)
- `createReportSchedule.response.500.request_id` (string, required)
- `createReportSchedule.response.500.docs_url` (string, required)
  - format `uri`
- `createReportSchedule.response.500.errors` (array<object>, optional)
  - `createReportSchedule.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `createReportSchedule.response.500.errors.code` (string, required)
  - `createReportSchedule.response.500.errors.detail` (string, required)
- `createReportSchedule.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/reports/createReportSchedule/index.md
